﻿import es
from gamethread import delayedname, cancelDelayed

#######

# if 1, then Radar always will be hidden from all alive players (but you can use hide_radar <userid> 0)
# if 0, then need use RCON Command: hide_radar <userid> <1/0>
hide_radar_always = 1

#######

players = []

es.ServerVar('hdr_version', 1.0, 'hide_radar / World-Source.Ru').makepublic()

def load():
	if not es.exists('command', 'hide_radar'):
		es.regcmd('hide_radar', 'wS_Hide_Radar/hide_radar_cmd', 'hide_radar <userid> <1/0>')
	if hide_radar_always:
		for i in es.getUseridList(): wS_Hide_Radar(i)

#######

def hide_radar_cmd():
	if es.getargc() != 3:
		es.dbgmsg(0, 'Syntax: hide_radar <userid> <1/0>')
		return
	i = int(es.getargv(1))
	if not es.exists('userid', i):
		es.dbgmsg(0, 'hide_radar error: userid %d not found' % i)
		return
	s = es.getargv(2)
	if not s.isdigit():
		es.dbgmsg(0, 'Syntax: hide_radar <userid> <1/0>')
		return
	es.setplayerprop(i, 'CCSPlayer.m_flFlashDuration', 0.0)
	es.setplayerprop(i, 'CCSPlayer.m_flFlashMaxAlpha', 0.0)
	if int(s) != 1:
		cancelDelayed('radar_%s' % i)
		if not hide_radar_always and i in players:
			players.remove(i)
	elif not hide_radar_always:
		es.delayed(0.1, 'es_xsetplayerprop %s CCSPlayer.m_flFlashDuration 9999.0' % i)
		if i not in players: players.append(i)

#######

def es_map_start(v):
	global players
	players = []

def player_disconnect(v):
	if not hide_radar_always:
		i = int(v['userid'])
		if i in players:
			cancelDelayed('radar_%s' % i)
			players.remove(i)

def player_spawn(v):
	i = int(v['userid'])
	if hide_radar_always or i in players:
		cancelDelayed('radar_%s' % i)
		wS_Hide_Radar(i)

def wS_Hide_Radar(i):
	es.setplayerprop(i, 'CCSPlayer.m_flFlashDuration', 0.0)
	es.setplayerprop(i, 'CCSPlayer.m_flFlashMaxAlpha', 0.0)
	es.delayed(0.1, 'es_xsetplayerprop %s CCSPlayer.m_flFlashDuration 9999.0' % i)

#######

def player_blind(v):
	i = int(v['userid'])
	if hide_radar_always or i in players:
		cancelDelayed('radar_%s' % i)
		delayedname(float(es.getplayerprop(i, 'CCSPlayer.m_flFlashDuration')), 'radar_%s' % i, hide_radar_again, i)

def hide_radar_again(i):
	wS_Hide_Radar(i)

# World-Source.Ru